/* AssistantBackup.c generated by valac, the Vala compiler
 * generated from AssistantBackup.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    Déjà Dup
    © 2008,2009 Michael Terry <mike@mterry.name>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <deja-dup.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <glib/gi18n-lib.h>
#include <hacks.h>


#define TYPE_ASSISTANT_OPERATION (assistant_operation_get_type ())
#define ASSISTANT_OPERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASSISTANT_OPERATION, AssistantOperation))
#define ASSISTANT_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASSISTANT_OPERATION, AssistantOperationClass))
#define IS_ASSISTANT_OPERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASSISTANT_OPERATION))
#define IS_ASSISTANT_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASSISTANT_OPERATION))
#define ASSISTANT_OPERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASSISTANT_OPERATION, AssistantOperationClass))

typedef struct _AssistantOperation AssistantOperation;
typedef struct _AssistantOperationClass AssistantOperationClass;
typedef struct _AssistantOperationPrivate AssistantOperationPrivate;

#define TYPE_ASSISTANT_BACKUP (assistant_backup_get_type ())
#define ASSISTANT_BACKUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASSISTANT_BACKUP, AssistantBackup))
#define ASSISTANT_BACKUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASSISTANT_BACKUP, AssistantBackupClass))
#define IS_ASSISTANT_BACKUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASSISTANT_BACKUP))
#define IS_ASSISTANT_BACKUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASSISTANT_BACKUP))
#define ASSISTANT_BACKUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASSISTANT_BACKUP, AssistantBackupClass))

typedef struct _AssistantBackup AssistantBackup;
typedef struct _AssistantBackupClass AssistantBackupClass;
typedef struct _AssistantBackupPrivate AssistantBackupPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AssistantOperation {
	GtkAssistant parent_instance;
	AssistantOperationPrivate * priv;
	GtkLabel* summary_label;
};

struct _AssistantOperationClass {
	GtkAssistantClass parent_class;
	GtkWidget* (*make_confirm_page) (AssistantOperation* self);
	void (*add_setup_pages) (AssistantOperation* self);
	void (*add_custom_config_pages) (AssistantOperation* self);
	DejaDupOperation* (*create_op) (AssistantOperation* self);
	char* (*get_progress_file_prefix) (AssistantOperation* self);
	GdkPixbuf* (*make_op_icon) (AssistantOperation* self);
	GtkWidget* (*make_progress_page) (AssistantOperation* self);
	void (*show_error) (AssistantOperation* self, DejaDupOperation* op, const char* _error_, const char* detail);
	GtkWidget* (*make_summary_page) (AssistantOperation* self);
	void (*do_prepare) (AssistantOperation* self, GtkAssistant* assist, GtkWidget* page);
	void (*do_close) (AssistantOperation* self);
};

struct _AssistantBackup {
	AssistantOperation parent_instance;
	AssistantBackupPrivate * priv;
};

struct _AssistantBackupClass {
	AssistantOperationClass parent_class;
};


static gpointer assistant_backup_parent_class = NULL;

GType assistant_operation_get_type (void);
GType assistant_backup_get_type (void);
enum  {
	ASSISTANT_BACKUP_DUMMY_PROPERTY
};
static GtkWidget* assistant_backup_make_backup_location_page (AssistantBackup* self);
static GtkWidget* assistant_backup_make_include_exclude_page (AssistantBackup* self);
GdkPixbuf* assistant_operation_get_op_icon (AssistantOperation* self);
static void assistant_backup_real_add_custom_config_pages (AssistantOperation* base);
static GtkWidget* assistant_backup_real_make_confirm_page (AssistantOperation* base);
static DejaDupOperation* assistant_backup_real_create_op (AssistantOperation* base);
static char* assistant_backup_real_get_progress_file_prefix (AssistantOperation* base);
static GdkPixbuf* assistant_backup_real_make_op_icon (AssistantOperation* base);
void assistant_operation_do_prepare (AssistantOperation* self, GtkAssistant* assist, GtkWidget* page);
GtkWidget* assistant_operation_get_summary_page (AssistantOperation* self);
gboolean assistant_operation_get_error_occurred (AssistantOperation* self);
GtkWidget* assistant_operation_get_progress_page (AssistantOperation* self);
static void assistant_backup_real_do_prepare (AssistantOperation* base, GtkAssistant* assist, GtkWidget* page);
AssistantBackup* assistant_backup_new (void);
AssistantBackup* assistant_backup_construct (GType object_type);
static GObject * assistant_backup_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);



static GtkWidget* assistant_backup_make_backup_location_page (AssistantBackup* self) {
	GtkWidget* result;
	gint rows;
	GtkWidget* w;
	GtkWidget* label;
	GtkTable* page;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	rows = 0;
	w = NULL;
	label = NULL;
	page = g_object_ref_sink ((GtkTable*) gtk_table_new ((guint) rows, (guint) 2, FALSE));
	g_object_set ((GObject*) page, "row-spacing", 6, "column-spacing", 6, "border-width", 12, NULL);
	w = (_tmp0_ = (GtkWidget*) g_object_ref_sink (deja_dup_config_location_new ()), _g_object_unref0 (w), _tmp0_);
	label = (_tmp1_ = (GtkWidget*) g_object_ref_sink ((GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Backup location:"))), _g_object_unref0 (label), _tmp1_);
	g_object_set ((GObject*) label, "xalign", 0.0f, "mnemonic-widget", w, NULL);
	gtk_table_attach (page, label, (guint) 0, (guint) 1, (guint) rows, (guint) (rows + 1), GTK_FILL, 0, (guint) 0, (guint) 0);
	gtk_table_attach (page, w, (guint) 1, (guint) 2, (guint) rows, (guint) (rows + 1), GTK_FILL | GTK_EXPAND, 0, (guint) 0, (guint) 0);
	rows = rows + 1;
	w = (_tmp2_ = (GtkWidget*) g_object_ref_sink (deja_dup_config_bool_new (DEJA_DUP_ENCRYPT_KEY, _ ("_Encrypt backup files"))), _g_object_unref0 (w), _tmp2_);
	gtk_table_attach (page, w, (guint) 0, (guint) 2, (guint) rows, (guint) (rows + 1), GTK_FILL | GTK_EXPAND, GTK_FILL, (guint) 0, (guint) 0);
	rows = rows + 1;
	result = (GtkWidget*) page;
	_g_object_unref0 (w);
	_g_object_unref0 (label);
	return result;
}


static GtkWidget* assistant_backup_make_include_exclude_page (AssistantBackup* self) {
	GtkWidget* result;
	gint rows;
	GtkWidget* w;
	GtkWidget* label;
	GtkTable* page;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	rows = 0;
	w = NULL;
	label = NULL;
	page = g_object_ref_sink ((GtkTable*) gtk_table_new ((guint) rows, (guint) 2, FALSE));
	g_object_set ((GObject*) page, "row-spacing", 6, "column-spacing", 6, "border-width", 12, NULL);
	w = (_tmp0_ = (GtkWidget*) g_object_ref_sink (deja_dup_config_list_new (DEJA_DUP_INCLUDE_LIST_KEY)), _g_object_unref0 (w), _tmp0_);
	gtk_widget_set_size_request (w, 250, -1);
	label = (_tmp1_ = (GtkWidget*) g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("I_nclude files in folders:"))), _g_object_unref0 (label), _tmp1_);
	g_object_set ((GObject*) label, "mnemonic-widget", w, "use-underline", TRUE, "wrap", TRUE, "width-request", 100, "xalign", 0.0f, "yalign", 0.0f, NULL);
	gtk_table_attach (page, label, (guint) 0, (guint) 1, (guint) rows, (guint) (rows + 1), GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
	gtk_table_attach (page, w, (guint) 1, (guint) 2, (guint) rows, (guint) (rows + 1), GTK_FILL | GTK_EXPAND, GTK_FILL, (guint) 0, (guint) 0);
	rows = rows + 1;
	w = (_tmp2_ = (GtkWidget*) g_object_ref_sink (deja_dup_config_list_new (DEJA_DUP_EXCLUDE_LIST_KEY)), _g_object_unref0 (w), _tmp2_);
	gtk_widget_set_size_request (w, 250, -1);
	label = (_tmp3_ = (GtkWidget*) g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("E_xcept files in folders:"))), _g_object_unref0 (label), _tmp3_);
	g_object_set ((GObject*) label, "mnemonic-widget", w, "use-underline", TRUE, "wrap", TRUE, "width-request", 100, "xalign", 0.0f, "yalign", 0.0f, NULL);
	gtk_table_attach (page, label, (guint) 0, (guint) 1, (guint) rows, (guint) (rows + 1), GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
	gtk_table_attach (page, w, (guint) 1, (guint) 2, (guint) rows, (guint) (rows + 1), GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_EXPAND, (guint) 0, (guint) 0);
	rows = rows + 1;
	result = (GtkWidget*) page;
	_g_object_unref0 (w);
	_g_object_unref0 (label);
	return result;
}


static void assistant_backup_real_add_custom_config_pages (AssistantOperation* base) {
	AssistantBackup * self;
	GtkWidget* page;
	GtkWidget* _tmp0_;
	self = (AssistantBackup*) base;
	page = assistant_backup_make_backup_location_page (self);
	gtk_assistant_append_page ((GtkAssistant*) self, page);
	gtk_container_child_set ((GtkContainer*) self, page, "title", _ ("Preferences"), "page-type", GTK_ASSISTANT_PAGE_CONTENT, "complete", TRUE, "header-image", assistant_operation_get_op_icon ((AssistantOperation*) self), NULL);
	page = (_tmp0_ = assistant_backup_make_include_exclude_page (self), _g_object_unref0 (page), _tmp0_);
	gtk_assistant_append_page ((GtkAssistant*) self, page);
	gtk_container_child_set ((GtkContainer*) self, page, "title", _ ("Preferences"), "page-type", GTK_ASSISTANT_PAGE_CONTENT, "complete", TRUE, "header-image", assistant_operation_get_op_icon ((AssistantOperation*) self), NULL);
	_g_object_unref0 (page);
}


static GtkWidget* assistant_backup_real_make_confirm_page (AssistantOperation* base) {
	AssistantBackup * self;
	GtkWidget* result;
	gint rows;
	GtkWidget* label;
	GtkWidget* w;
	GtkTable* page;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	GtkWidget* _tmp7_;
	self = (AssistantBackup*) base;
	rows = 0;
	label = NULL;
	w = NULL;
	page = g_object_ref_sink ((GtkTable*) gtk_table_new ((guint) rows, (guint) 2, FALSE));
	g_object_set ((GObject*) page, "row-spacing", 6, "column-spacing", 6, "border-width", 12, NULL);
	label = (_tmp0_ = (GtkWidget*) g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Backup location:"))), _g_object_unref0 (label), _tmp0_);
	g_object_set ((GObject*) label, "xalign", 0.0f, NULL);
	w = (_tmp1_ = (GtkWidget*) g_object_ref_sink (deja_dup_config_label_location_new ()), _g_object_unref0 (w), _tmp1_);
	gtk_table_attach (page, label, (guint) 0, (guint) 1, (guint) rows, (guint) (rows + 1), GTK_FILL, 0, (guint) 0, (guint) 0);
	gtk_table_attach (page, w, (guint) 1, (guint) 2, (guint) rows, (guint) (rows + 1), GTK_FILL, 0, (guint) 0, (guint) 0);
	rows = rows + 1;
	label = (_tmp2_ = (GtkWidget*) g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Encrypted:"))), _g_object_unref0 (label), _tmp2_);
	g_object_set ((GObject*) label, "xalign", 0.0f, NULL);
	w = (_tmp3_ = (GtkWidget*) g_object_ref_sink (deja_dup_config_label_bool_new (DEJA_DUP_ENCRYPT_KEY)), _g_object_unref0 (w), _tmp3_);
	gtk_table_attach (page, label, (guint) 0, (guint) 1, (guint) rows, (guint) (rows + 1), GTK_FILL, 0, (guint) 0, (guint) 0);
	gtk_table_attach (page, w, (guint) 1, (guint) 2, (guint) rows, (guint) (rows + 1), GTK_FILL, 0, (guint) 0, (guint) 0);
	rows = rows + 1;
	label = (_tmp4_ = (GtkWidget*) g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Include from:"))), _g_object_unref0 (label), _tmp4_);
	g_object_set ((GObject*) label, "xalign", 0.0f, "yalign", 0.0f, NULL);
	w = (_tmp5_ = (GtkWidget*) g_object_ref_sink (deja_dup_config_label_list_new (DEJA_DUP_INCLUDE_LIST_KEY)), _g_object_unref0 (w), _tmp5_);
	g_object_set ((GObject*) w, "width-request", 250, NULL);
	gtk_table_attach (page, label, (guint) 0, (guint) 1, (guint) rows, (guint) (rows + 1), GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
	gtk_table_attach (page, w, (guint) 1, (guint) 2, (guint) rows, (guint) (rows + 1), 0, GTK_FILL, (guint) 0, (guint) 0);
	rows = rows + 1;
	label = (_tmp6_ = (GtkWidget*) g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Except for:"))), _g_object_unref0 (label), _tmp6_);
	g_object_set ((GObject*) label, "xalign", 0.0f, "yalign", 0.0f, NULL);
	w = (_tmp7_ = (GtkWidget*) g_object_ref_sink (deja_dup_config_label_list_new (DEJA_DUP_EXCLUDE_LIST_KEY)), _g_object_unref0 (w), _tmp7_);
	g_object_set ((GObject*) w, "width-request", 250, NULL);
	gtk_table_attach (page, label, (guint) 0, (guint) 1, (guint) rows, (guint) (rows + 1), GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
	gtk_table_attach (page, w, (guint) 1, (guint) 2, (guint) rows, (guint) (rows + 1), 0, GTK_FILL, (guint) 0, (guint) 0);
	rows = rows + 1;
	result = (GtkWidget*) page;
	_g_object_unref0 (label);
	_g_object_unref0 (w);
	return result;
}


static DejaDupOperation* assistant_backup_real_create_op (AssistantOperation* base) {
	AssistantBackup * self;
	DejaDupOperation* result;
	self = (AssistantBackup*) base;
	result = (DejaDupOperation*) deja_dup_operation_backup_new ((GtkWindow*) self, 0);
	return result;
}


static char* assistant_backup_real_get_progress_file_prefix (AssistantOperation* base) {
	AssistantBackup * self;
	char* result;
	self = (AssistantBackup*) base;
	result = g_strdup (_ ("Backing up"));
	return result;
}


static GdkPixbuf* assistant_backup_real_make_op_icon (AssistantOperation* base) {
	AssistantBackup * self;
	GdkPixbuf* result;
	GError * _inner_error_;
	self = (AssistantBackup*) base;
	_inner_error_ = NULL;
	{
		GdkPixbuf* _tmp0_;
		_tmp0_ = hacks_get_icon_at_size ("deja-dup-backup", 48, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
			goto __finally0;
		}
		result = _tmp0_;
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("AssistantBackup.vala:175: %s\n", e->message);
			result = NULL;
			_g_error_free0 (e);
			return result;
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void assistant_backup_real_do_prepare (AssistantOperation* base, GtkAssistant* assist, GtkWidget* page) {
	AssistantBackup * self;
	self = (AssistantBackup*) base;
	g_return_if_fail (assist != NULL);
	g_return_if_fail (page != NULL);
	ASSISTANT_OPERATION_CLASS (assistant_backup_parent_class)->do_prepare (ASSISTANT_OPERATION (self), assist, page);
	if (page == assistant_operation_get_summary_page ((AssistantOperation*) self)) {
		if (assistant_operation_get_error_occurred ((AssistantOperation*) self)) {
			gtk_container_child_set ((GtkContainer*) assist, page, "title", _ ("Backup Failed"), NULL);
		} else {
			gtk_container_child_set ((GtkContainer*) assist, page, "title", _ ("Backup Finished"), NULL);
			gtk_label_set_label (((AssistantOperation*) self)->summary_label, _ ("Your files were successfully backed up."));
		}
	} else {
		if (page == assistant_operation_get_progress_page ((AssistantOperation*) self)) {
			gtk_container_child_set ((GtkContainer*) assist, page, "title", _ ("Backing up..."), NULL);
		}
	}
}


AssistantBackup* assistant_backup_construct (GType object_type) {
	AssistantBackup * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


AssistantBackup* assistant_backup_new (void) {
	return assistant_backup_construct (TYPE_ASSISTANT_BACKUP);
}


static GObject * assistant_backup_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	AssistantBackup * self;
	parent_class = G_OBJECT_CLASS (assistant_backup_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = ASSISTANT_BACKUP (obj);
	{
		gtk_window_set_title ((GtkWindow*) self, _ ("Backup"));
	}
	return obj;
}


static void assistant_backup_class_init (AssistantBackupClass * klass) {
	assistant_backup_parent_class = g_type_class_peek_parent (klass);
	ASSISTANT_OPERATION_CLASS (klass)->add_custom_config_pages = assistant_backup_real_add_custom_config_pages;
	ASSISTANT_OPERATION_CLASS (klass)->make_confirm_page = assistant_backup_real_make_confirm_page;
	ASSISTANT_OPERATION_CLASS (klass)->create_op = assistant_backup_real_create_op;
	ASSISTANT_OPERATION_CLASS (klass)->get_progress_file_prefix = assistant_backup_real_get_progress_file_prefix;
	ASSISTANT_OPERATION_CLASS (klass)->make_op_icon = assistant_backup_real_make_op_icon;
	ASSISTANT_OPERATION_CLASS (klass)->do_prepare = assistant_backup_real_do_prepare;
	G_OBJECT_CLASS (klass)->constructor = assistant_backup_constructor;
}


static void assistant_backup_instance_init (AssistantBackup * self) {
}


GType assistant_backup_get_type (void) {
	static GType assistant_backup_type_id = 0;
	if (assistant_backup_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (AssistantBackupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) assistant_backup_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AssistantBackup), 0, (GInstanceInitFunc) assistant_backup_instance_init, NULL };
		assistant_backup_type_id = g_type_register_static (TYPE_ASSISTANT_OPERATION, "AssistantBackup", &g_define_type_info, 0);
	}
	return assistant_backup_type_id;
}




